<template>
    <div class="reactive-power">
        <div class="control-container">
            <div>
                <div class="control-item">
                    <span class="control-item-title">电网有功调度指令</span>
                    <span class="control-item-img">
                        <img :src="emsGridDispathActEnabled ? imgOn : imgOff" />
                    </span>
                </div>
                <div class="control-item">
                    <span class="control-item-title">电网有功调度指令值</span>
                    <span class="control-item-value">
                        <span class="num">{{ emsGridDispatchAct }}</span>
                        <span class="unit">{{ emsGridDispatchActUnit }}</span>
                    </span>
                </div>
                <div class="control-item">
                    <span class="control-item-title">风场总有功</span>
                    <span class="control-item-value orign">
                        <span class="num">{{ factoryPowAct }}</span>
                        <span class="unit">{{ factoryPowActUnit }}</span>
                    </span>
                </div>
            </div>
            <div id="chart-container"></div>
        </div>
        <div class="crew-container">
            <!-- <el-scrollbar class="editScroll">
                <div class="scroll-content"> -->
            <el-table border height="100%" size="mini" style="width: 100%" :data="tableData"
                :default-sort="{ prop: 'fancode', order: 'ascending' }">
                <el-table-column type="index" min-width="5%" label="序号" align="center">
                </el-table-column>
                <el-table-column prop="fanName" min-width="10%" label="机组名称" show-overflow-tooltip align="center">
                </el-table-column>
                <el-table-column v-for="col in columns" :key="col.prop" :prop="col.prop" :label="col.label"
                    :width="col.width" :min-width="col.minWidth" align="center" show-overflow-tooltip sortable>
                    <template slot-scope="scope">
                        <!-- <el-tooltip
                            :content="`${col.label}: ${scope.row[col.prop]}`"
                        > -->
                        <!-- <span v-if="col.prop == 'fanName'">
                            {{ scope.row[col.prop] }}
                        </span> -->
                        <span>
                            <span class="table-value" :class="`${col.prop}`">{{
        scope.row[col.prop]
}}</span>
                            <span class="table-value-unit">{{
        scope.row[`${col.prop}Unit`]
}}</span>
                        </span>
                        <!-- </el-tooltip> -->
                    </template>
                </el-table-column>
                <el-table-column prop="iconDiffer" label="对比图" align="center" min-width="40%">
                    <template slot="header">
                        <div class="differ-header">
                            <span>对比图</span>
                            <span class="differ-header-var_50">
                                <span class="differ-icon"></span>
                                有功分配值
                            </span>
                            <span class="differ-header-powAct">
                                <span class="differ-icon"></span>
                                有功功率
                            </span>
                        </div>
                    </template>
                    <template slot-scope="scope">
                        <div class="iconDiffer-outer">
                            <div class="iconDiffer-outer-border var_50">
                                <div :style="{
    width: `${scope.row.widthV}%`,
}" class="iconDiffer var_50"></div>

                                <span class="iconDiffer-value var_50">{{
        scope.row.var_50
}}</span>
                            </div>
                            <div class="iconDiffer-outer-border powAct">
                                <div :style="{
    width: `${scope.row.widthP}%`,
}" class="iconDiffer powAct"></div>
                                <span class="iconDiffer-value powAct">{{
        scope.row.powAct
                                    }}</span>
                            </div>
                        </div>
                    </template>
                </el-table-column>
            </el-table>
        </div>
    </div>
</template>

<script>
import { Bar } from '@antv/g2plot'
import { Chart } from '@antv/g2'
import utils from '@/hotent-ui-util'
export default {
    name: 'reactivePower',
    data() {
        return {
            imgOn: require('@/assets/img/buttonOn.png'),
            imgOff: require('@/assets/img/buttonOff.png'),
            tableHeight: 300,
            accecptData: false,
            emsGridDispathActEnabled: false,
            emsGridDispatchAct: 0,
            emsGridDispatchActUnit: '',
            factoryPowAct: 0,
            factoryPowActUnit: '',
            columns: [
                // {
                //     label: '机组名称',
                //     prop: 'fanName',
                //     minWidth: '15%',
                //     sortable: true,
                // },
                {
                    label: '风速',
                    prop: 'winSpd',
                    minWidth: '15%',
                    sortable: true,
                    unit: 'm/s',
                },
                {
                    label: '有功分配值',
                    prop: 'var_50',
                    minWidth: '15%',
                    sortable: true,
                    unit: 'kW',
                },
                {
                    label: '有功功率',
                    prop: 'powAct',
                    minWidth: '15%',
                    sortable: true,
                    unit: 'kW',
                },
            ],
            tableData: [],
            maxOriginValue: 0,
            maxValue: 0,
            chart: null,
            chartData: [],
        }
    },
    created() { },
    mounted() {
        this.initCrewList()
        this.accecptData = true
        this.$bus.$on('SCADAMsg', (data) => {
            if (this.accecptData) {
                console.log(data)
                this.changeData(data)
            }
        })
        this.$nextTick(() => {
            this.initChart()
        })
    },
    beforeDestroy() {
        this.accecptData = false
    },
    methods: {
        initCrewList() {
            let query = {
                sorter: [{ direction: 'ASC', property: 'sn' }],
            }
            this.$http.post('${cssc}/biz/base/fanInfo/v1/list', query).then(
                (resp) => {
                    if (resp.data) {
                        this.formatFan(resp.data)
                    }
                },
                (error) => {
                    reject(error)
                }
            )
        },
        formatFan(data) {
            this.crewsList = []
            data.forEach((item, index) => {
                this.crewsList.push({
                    fancode: item.fanCode,
                    fanName: item.fanName,
                    var_50: null,
                    powAct: null,
                })
            })
        },
        // 电网调度有功 emsGridDispathActEnabled 布尔
        // 电网有功调度值 emsGridDispatchAct 浮点
        // 有功功率用powAct
        // 有功分配用var_50
        initChart() {
            this.chart = new Chart({
                container: 'chart-container',
                autoFit: true,
            })
            this.chart.data(this.chartData)
            this.chart.scale({
                date: {
                    alias: '时间',
                    type: 'time',
                    formatter: (value) => {
                        return utils.formatDate(value, 'time')
                    },
                },
                value: {
                    sync: true, // 将数值同 date 字段数值进行同步
                    nice: true,
                    min: 0,
                },
            })
            this.chart.axis('date', {
                grid: null,
                label: {
                    style: {
                        fill: '#979ba4',
                    },
                },
                line: {
                    style: {
                        stroke: '#414959',
                    },
                },
            })
            this.chart.axis('value', {
                grid: {
                    line: {
                        style: {
                            stroke: '#414959',
                            lineWidth: 1,
                            lineDash: [3, 3],
                        },
                    },
                },
                label: {
                    style: {
                        fill: '#979ba4',
                    },
                    formatter: (val) => {
                        return val + " " + this.emsGridDispatchActUnit
                    },
                },
                line: {
                    style: {
                        stroke: '#414959',
                    },
                },
            })

            this.chart.legend({
                position: 'top',
                itemName: {
                    style: {
                        fill: '#979ba4',
                    },
                },
            })
            this.chart.tooltip({
                shared: true,
                showCrosshairs: true,
                domStyles: {
                    'g2-tooltip': {
                        background: 'rgba(0,0,0, 0.8)',
                        color: '#d6e0ec',
                    },
                },
            })
            this.chart
                .line()
                .position('date*value')
                .color('type', ['#399873', '#ff9c00'])
            this.chart.interaction('active-region')
            this.chart.render()
        },

        changeData(data) {
            if (data.wind) {
                this.emsGridDispathActEnabled = data.wind
                    .emsGridDispathActEnabled
                    ? data.wind.emsGridDispathActEnabled.val
                    : false // 电网调度有功指令

                this.emsGridDispatchAct = data.wind.emsGridDispatchAct
                    ? data.wind.emsGridDispatchAct.val
                    : 0 // 电网调度有功指令值
                this.emsGridDispatchActUnit = data.wind.emsGridDispatchAct
                    ? data.wind.emsGridDispatchAct.unit
                    : ''// 电网调度有功指令值

                this.factoryPowAct = data.wind.factoryPowAct
                    ? data.wind.factoryPowAct.val
                    : 0 // 风场总有功
                this.factoryPowActUnit = data.wind.factoryPowAct
                    ? data.wind.factoryPowAct.unit
                    : ''

                if (data.wind.emsGridDispatchAct || data.wind.factoryPowAct) {
                    let newData1 = {
                        date: parseInt(data.time),
                        value: data.wind.emsGridDispatchAct
                            ? data.wind.emsGridDispatchAct.val
                            : null,
                        type: '电网有功调度指令值',
                    }
                    let newData2 = {
                        date: parseInt(data.time),
                        value: data.wind.factoryPowAct
                            ? data.wind.factoryPowAct.val
                            : null,
                        type: '风场总有功',
                    }
                    this.chartData.push(newData1, newData2)
                    if (this.chartData.length > 600) {
                        this.chartData.splice(0, 2)
                    }
                    this.chart.changeData(this.chartData)
                }
            }
            if (data.fan) {
                this.maxOriginValue = 0
                this.maxValue = 0
                if (this.crewsList) {
                    this.crewsList.forEach((item) => {
                        item.winSpd = data.fan[item.fancode].winSpd
                            ? data.fan[item.fancode].winSpd.val
                            : null
                        item.winSpdUnit = data.fan[item.fancode].winSpd
                            ? data.fan[item.fancode].winSpd.unit
                            : null
                        item.var_50 = data.fan[item.fancode].var_50
                            ? data.fan[item.fancode].var_50.val
                            : null
                        item.var_50Unit = data.fan[item.fancode].var_50
                            ? data.fan[item.fancode].var_50.unit
                            : null
                        item.powAct = data.fan[item.fancode].powAct
                            ? data.fan[item.fancode].powAct.val
                            : null
                        item.powActUnit = data.fan[item.fancode].powAct
                            ? data.fan[item.fancode].powAct.unit
                            : null
                        this.maxOriginValue = Math.max(
                            this.maxOriginValue,
                            item.var_50,
                            item.powAct
                        )
                    })
                    this.maxValue = this.maxOriginValue
                    this.crewsList.forEach((item) => {
                        item.widthV =
                            Math.round((item.var_50 / this.maxValue) * 10000) / 100
                        item.widthP =
                            Math.round((item.powAct / this.maxValue) * 10000) / 100
                    })
                    this.tableData = this.crewsList
                }
            }
        },
    },
}
</script>

<style lang="scss" scoped>
@import '@/assets/css/element-variables.scss';

.reactive-power {
    width: 100%;
    height: 100%;
    color: $--color-text;

    .differ-header {
        span {
            display: inline-block;
        }

        .differ-header-var_50 {
            margin-left: 20px;

            .differ-icon {
                background: linear-gradient(to right, #5796c4, #1883cf);
            }
        }

        .differ-header-powAct {
            margin-left: 20px;

            .differ-icon {
                background: linear-gradient(to right, #6ccca7, #31c78d);
            }
        }

        .differ-icon {
            width: 8px;
            height: 8px;
            border-radius: 10px;
        }


    }

    .table-value {
        font-size: 14px;
        font-family: 'electronicFont';
        color: #44abf5;
    }

    .table-value.powAct {
        color: #41b78a;
    }

    .table-value-unit {
        font-size: 12px;
        font-weight: normal;
        margin-left: 10px;
    }

    .iconDiffer-outer {
        width: 100%;
    }

    .iconDiffer-outer-border {
        width: 86%;
        height: 12px;
        border: 1px solid #1b9a69;
        display: flex;
        align-items: center;
        position: relative;
    }

    .iconDiffer-outer-border.var_50 {
        border: 1px solid #1979be;
        margin-bottom: 4px;
    }

    .iconDiffer {
        height: 5px;
        margin-left: 2px;
        margin-right: 2px;
    }

    .iconDiffer.var_50 {
        background: linear-gradient(to right, #5796c4, #1979be);

    }

    .iconDiffer.powAct {
        background: linear-gradient(to right, #4f967a, #1b9a69);
    }

    .iconDiffer-value {
        position: absolute;
        left: 100%;
        width: 12%;
        color: #44abf5;
    }

    .iconDiffer-value.powAct {
        color: #41b78a;
    }

    .control-container {
        height: 200px;
        margin-bottom: 10px;
        width: 100%;
        background-color: rgba(18, 60, 88, 0.5);
        border: 1px solid #25b4be;
        box-sizing: border-box;
        border-radius: 4px;
        display: flex;
        justify-content: space-around;
        align-items: center;
    }

    #chart-container {
        width: calc(100% - 460px);
        height: 98%;
        margin-right: 20px;
    }

    .control-item {
        width: 400px;
        height: 60px;
        line-height: 60px;
        margin: 0 80px;
        display: flex;
        justify-content: start;
        align-items: center;

        span {
            font-size: 20px;
            font-weight: 700;
            vertical-align: middle;
        }

        .control-item-value {
            margin-left: 20px;
            margin-top: 6px;

            .num {
                font-family: 'electronicFont';
                vertical-align: middle;
                color: #02c82e;
            }

            .unit {
                font-size: 12px;
                color: #868e99;
                font-weight: normal;
                margin-left: 6px;
            }
        }

        .control-item-value.orign {
            .num {
                color: #ff9c00;
            }
        }

        .control-item-img {
            margin-left: 20px;
            width: 40px;
            height: 40px;

            img {
                width: 100%;
                height: 100%;
            }
        }

        /deep/ .el-switch__label {
            color: #0e4456;
            font-weight: 700;
        }

        /deep/ .el-switch__label.is-active {
            color: #25b4be;
        }
    }

    .crew-container {
        width: 100%;
        height: calc(100% - 210px);
    }

    .editScroll {
        height: 100% !important;
        overflow-x: hidden;

        /deep/ .el-scrollbar__wrap {
            overflow-x: hidden;
        }

        /deep/ .el-scrollbar__view {
            overflow-x: hidden;
            width: 100% !important;
            height: 100% !important;
        }
    }

    .scroll-content {
        display: flex;
        width: 100%;
        height: 100%;
    }

    #chartContainer {
        width: calc(50% - 20px);
        margin-left: 20px;
    }

    .scroll-crews-container {
        display: flex;
        flex-wrap: wrap;
        justify-content: start;
        // margin-right: -10px;
    }

    .card {
        background-color: rgba(18, 60, 88, 0.5);
        border: 1px solid #25b4be;
        box-sizing: border-box;
        border-radius: 4px;
        height: 100px;
        padding: 10px;
        box-sizing: border-box;
        margin-top: 10px;
        position: relative;

        :hover {
            cursor: pointer;
        }
    }

    .crew-item-content {
        width: 100%;
        height: 100%;
        color: $--color-text;
        box-sizing: border-box;
        position: relative;
    }

    .crew-img {
        width: 60px;
        height: 60px;
        position: absolute;
        right: 0;
        bottom: 0;
        opacity: 0.25;
    }

    .crew-img2 {
        width: 40px;
        height: 40px;
        position: absolute;
        right: 40px;
        bottom: 0;
        opacity: 0.2;
    }

    .crew-name {
        font-weight: 700;
        font-size: 18px;
        color: $--color-text;
    }

    .crew-point {
        width: 80%;
        margin: 0 auto;
        font-size: 12px;
        margin-top: 6px;

        span {
            margin-left: 10px;
            color: #25b4be;
        }
    }
}
</style>